profunctors-5.1.2: Profunctors

Safe Haskell | Safe
Language | Haskell2010

Data.Profunctor.Monad

# Documentation

class ProfunctorFunctor t where Source

Methods

promap :: Profunctor p => (p :-> q) -> t p :-> t q Source

Instances

ProfunctorFunctor Environment Source |
ProfunctorFunctor Closure Source |
ProfunctorFunctor Copastro Source |
ProfunctorFunctor Cotambara Source |
ProfunctorFunctor Pastro Source |
ProfunctorFunctor Tambara Source |
Functor f => ProfunctorFunctor (Cayley f) Source |
ProfunctorFunctor (Rift p) Source |
ProfunctorFunctor (Procompose p) Source |
ProfunctorFunctor (Ran p) Source |

class ProfunctorFunctor t => ProfunctorMonad t where Source

Methods

proreturn :: Profunctor p => p :-> t p Source

projoin :: Profunctor p => t (t p) :-> t p Source

Instances

ProfunctorMonad Environment Source |
ProfunctorMonad Copastro Source |
ProfunctorMonad Pastro Source |
(Functor f, Monad f) => ProfunctorMonad (Cayley f) Source | Cayley transforms Monads in `Hask` into monads on `Prof`
Category * p => ProfunctorMonad (Procompose p) Source |

class ProfunctorFunctor t => ProfunctorComonad t where Source

Methods

proextract :: Profunctor p => t p :-> p Source

produplicate :: Profunctor p => t p :-> t (t p) Source

Instances

ProfunctorComonad Closure Source |
ProfunctorComonad Cotambara Source |
ProfunctorComonad Tambara Source |
Comonad f => ProfunctorComonad (Cayley f) Source | Cayley transforms Comonads in `Hask` into comonads on `Prof`
Category * p => ProfunctorComonad (Rift p) Source |
Category * p => ProfunctorComonad (Ran p) Source |